<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=edge"><![endif]-->
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta name="generator" content="Asciidoctor 1.5.8">
<title>Leadium Framework</title>
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700">
<style>
/* Asciidoctor default stylesheet | MIT License | http://asciidoctor.org */
/* Uncomment @import statement below to use as custom stylesheet */
/*@import "https://fonts.googleapis.com/css?family=Open+Sans:300,300italic,400,400italic,600,600italic%7CNoto+Serif:400,400italic,700,700italic%7CDroid+Sans+Mono:400,700";*/
article,aside,details,figcaption,figure,footer,header,hgroup,main,nav,section,summary{display:block}
audio,canvas,video{display:inline-block}
audio:not([controls]){display:none;height:0}
script{display:none!important}
html{font-family:sans-serif;-ms-text-size-adjust:100%;-webkit-text-size-adjust:100%}
a{background:transparent}
a:focus{outline:thin dotted}
a:active,a:hover{outline:0}
h1{font-size:2em;margin:.67em 0}
abbr[title]{border-bottom:1px dotted}
b,strong{font-weight:bold}
dfn{font-style:italic}
hr{-moz-box-sizing:content-box;box-sizing:content-box;height:0}
mark{background:#ff0;color:#000}
code,kbd,pre,samp{font-family:monospace;font-size:1em}
pre{white-space:pre-wrap}
q{quotes:"\201C" "\201D" "\2018" "\2019"}
small{font-size:80%}
sub,sup{font-size:75%;line-height:0;position:relative;vertical-align:baseline}
sup{top:-.5em}
sub{bottom:-.25em}
img{border:0}
svg:not(:root){overflow:hidden}
figure{margin:0}
fieldset{border:1px solid silver;margin:0 2px;padding:.35em .625em .75em}
legend{border:0;padding:0}
button,input,select,textarea{font-family:inherit;font-size:100%;margin:0}
button,input{line-height:normal}
button,select{text-transform:none}
button,html input[type="button"],input[type="reset"],input[type="submit"]{-webkit-appearance:button;cursor:pointer}
button[disabled],html input[disabled]{cursor:default}
input[type="checkbox"],input[type="radio"]{box-sizing:border-box;padding:0}
button::-moz-focus-inner,input::-moz-focus-inner{border:0;padding:0}
textarea{overflow:auto;vertical-align:top}
table{border-collapse:collapse;border-spacing:0}
*,*::before,*::after{-moz-box-sizing:border-box;-webkit-box-sizing:border-box;box-sizing:border-box}
html,body{font-size:100%}
body{background:#fff;color:rgba(0,0,0,.8);padding:0;margin:0;font-family:"Noto Serif","DejaVu Serif",serif;font-weight:400;font-style:normal;line-height:1;position:relative;cursor:auto;tab-size:4;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased}
a:hover{cursor:pointer}
img,object,embed{max-width:100%;height:auto}
object,embed{height:100%}
img{-ms-interpolation-mode:bicubic}
.left{float:left!important}
.right{float:right!important}
.text-left{text-align:left!important}
.text-right{text-align:right!important}
.text-center{text-align:center!important}
.text-justify{text-align:justify!important}
.hide{display:none}
img,object,svg{display:inline-block;vertical-align:middle}
textarea{height:auto;min-height:50px}
select{width:100%}
.center{margin-left:auto;margin-right:auto}
.stretch{width:100%}
.subheader,.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{line-height:1.45;color:#7a2518;font-weight:400;margin-top:0;margin-bottom:.25em}
div,dl,dt,dd,ul,ol,li,h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6,pre,form,p,blockquote,th,td{margin:0;padding:0;direction:ltr}
a{color:#2156a5;text-decoration:underline;line-height:inherit}
a:hover,a:focus{color:#1d4b8f}
a img{border:none}
p{font-family:inherit;font-weight:400;font-size:1em;line-height:1.6;margin-bottom:1.25em;text-rendering:optimizeLegibility}
p aside{font-size:.875em;line-height:1.35;font-style:italic}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{font-family:"Open Sans","DejaVu Sans",sans-serif;font-weight:300;font-style:normal;color:#ba3925;text-rendering:optimizeLegibility;margin-top:1em;margin-bottom:.5em;line-height:1.0125em}
h1 small,h2 small,h3 small,#toctitle small,.sidebarblock>.content>.title small,h4 small,h5 small,h6 small{font-size:60%;color:#e99b8f;line-height:0}
h1{font-size:2.125em}
h2{font-size:1.6875em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.375em}
h4,h5{font-size:1.125em}
h6{font-size:1em}
hr{border:solid #dddddf;border-width:1px 0 0;clear:both;margin:1.25em 0 1.1875em;height:0}
em,i{font-style:italic;line-height:inherit}
strong,b{font-weight:bold;line-height:inherit}
small{font-size:60%;line-height:inherit}
code{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;font-weight:400;color:rgba(0,0,0,.9)}
ul,ol,dl{font-size:1em;line-height:1.6;margin-bottom:1.25em;list-style-position:outside;font-family:inherit}
ul,ol{margin-left:1.5em}
ul li ul,ul li ol{margin-left:1.25em;margin-bottom:0;font-size:1em}
ul.square li ul,ul.circle li ul,ul.disc li ul{list-style:inherit}
ul.square{list-style-type:square}
ul.circle{list-style-type:circle}
ul.disc{list-style-type:disc}
ol li ul,ol li ol{margin-left:1.25em;margin-bottom:0}
dl dt{margin-bottom:.3125em;font-weight:bold}
dl dd{margin-bottom:1.25em}
abbr,acronym{text-transform:uppercase;font-size:90%;color:rgba(0,0,0,.8);border-bottom:1px dotted #ddd;cursor:help}
abbr{text-transform:none}
blockquote{margin:0 0 1.25em;padding:.5625em 1.25em 0 1.1875em;border-left:1px solid #ddd}
blockquote cite{display:block;font-size:.9375em;color:rgba(0,0,0,.6)}
blockquote cite::before{content:"\2014 \0020"}
blockquote cite a,blockquote cite a:visited{color:rgba(0,0,0,.6)}
blockquote,blockquote p{line-height:1.6;color:rgba(0,0,0,.85)}
@media screen and (min-width:768px){h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2}
h1{font-size:2.75em}
h2{font-size:2.3125em}
h3,#toctitle,.sidebarblock>.content>.title{font-size:1.6875em}
h4{font-size:1.4375em}}
table{background:#fff;margin-bottom:1.25em;border:solid 1px #dedede}
table thead,table tfoot{background:#f7f8f7}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;color:rgba(0,0,0,.8);text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit;color:rgba(0,0,0,.8)}
table tr.even,table tr.alt,table tr:nth-of-type(even){background:#f8f8f7}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
h1,h2,h3,#toctitle,.sidebarblock>.content>.title,h4,h5,h6{line-height:1.2;word-spacing:-.05em}
h1 strong,h2 strong,h3 strong,#toctitle strong,.sidebarblock>.content>.title strong,h4 strong,h5 strong,h6 strong{font-weight:400}
.clearfix::before,.clearfix::after,.float-group::before,.float-group::after{content:" ";display:table}
.clearfix::after,.float-group::after{clear:both}
*:not(pre)>code{font-size:.9375em;font-style:normal!important;letter-spacing:0;padding:.1em .5ex;word-spacing:-.15em;background-color:#f7f7f8;-webkit-border-radius:4px;border-radius:4px;line-height:1.45;text-rendering:optimizeSpeed;word-wrap:break-word}
*:not(pre)>code.nobreak{word-wrap:normal}
*:not(pre)>code.nowrap{white-space:nowrap}
pre,pre>code{line-height:1.45;color:rgba(0,0,0,.9);font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;font-weight:400;text-rendering:optimizeSpeed}
em em{font-style:normal}
strong strong{font-weight:400}
.keyseq{color:rgba(51,51,51,.8)}
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background-color:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}
.menuseq,.menuref{color:#000}
.menuseq b:not(.caret),.menuref{font-weight:inherit}
.menuseq{word-spacing:-.02em}
.menuseq b.caret{font-size:1.25em;line-height:.8}
.menuseq i.caret{font-weight:bold;text-align:center;width:.45em}
b.button::before,b.button::after{position:relative;top:-1px;font-weight:400}
b.button::before{content:"[";padding:0 3px 0 2px}
b.button::after{content:"]";padding:0 2px 0 3px}
p a>code:hover{color:rgba(0,0,0,.9)}
#header,#content,#footnotes,#footer{width:100%;margin-left:auto;margin-right:auto;margin-top:0;margin-bottom:0;max-width:62.5em;*zoom:1;position:relative;padding-left:.9375em;padding-right:.9375em}
#header::before,#header::after,#content::before,#content::after,#footnotes::before,#footnotes::after,#footer::before,#footer::after{content:" ";display:table}
#header::after,#content::after,#footnotes::after,#footer::after{clear:both}
#content{margin-top:1.25em}
#content::before{content:none}
#header>h1:first-child{color:rgba(0,0,0,.85);margin-top:2.25rem;margin-bottom:0}
#header>h1:first-child+#toc{margin-top:8px;border-top:1px solid #dddddf}
#header>h1:only-child,body.toc2 #header>h1:nth-last-child(2){border-bottom:1px solid #dddddf;padding-bottom:8px}
#header .details{border-bottom:1px solid #dddddf;line-height:1.45;padding-top:.25em;padding-bottom:.25em;padding-left:.25em;color:rgba(0,0,0,.6);display:-ms-flexbox;display:-webkit-flex;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap}
#header .details span:first-child{margin-left:-.125em}
#header .details span.email a{color:rgba(0,0,0,.85)}
#header .details br{display:none}
#header .details br+span::before{content:"\00a0\2013\00a0"}
#header .details br+span.author::before{content:"\00a0\22c5\00a0";color:rgba(0,0,0,.85)}
#header .details br+span#revremark::before{content:"\00a0|\00a0"}
#header #revnumber{text-transform:capitalize}
#header #revnumber::after{content:"\00a0"}
#content>h1:first-child:not([class]){color:rgba(0,0,0,.85);border-bottom:1px solid #dddddf;padding-bottom:8px;margin-top:0;padding-top:1rem;margin-bottom:1.25rem}
#toc{border-bottom:1px solid #e7e7e9;padding-bottom:.5em}
#toc>ul{margin-left:.125em}
#toc ul.sectlevel0>li>a{font-style:italic}
#toc ul.sectlevel0 ul.sectlevel1{margin:.5em 0}
#toc ul{font-family:"Open Sans","DejaVu Sans",sans-serif;list-style-type:none}
#toc li{line-height:1.3334;margin-top:.3334em}
#toc a{text-decoration:none}
#toc a:active{text-decoration:underline}
#toctitle{color:#7a2518;font-size:1.2em}
@media screen and (min-width:768px){#toctitle{font-size:1.375em}
body.toc2{padding-left:15em;padding-right:0}
#toc.toc2{margin-top:0!important;background-color:#f8f8f7;position:fixed;width:15em;left:0;top:0;border-right:1px solid #e7e7e9;border-top-width:0!important;border-bottom-width:0!important;z-index:1000;padding:1.25em 1em;height:100%;overflow:auto}
#toc.toc2 #toctitle{margin-top:0;margin-bottom:.8rem;font-size:1.2em}
#toc.toc2>ul{font-size:.9em;margin-bottom:0}
#toc.toc2 ul ul{margin-left:0;padding-left:1em}
#toc.toc2 ul.sectlevel0 ul.sectlevel1{padding-left:0;margin-top:.5em;margin-bottom:.5em}
body.toc2.toc-right{padding-left:0;padding-right:15em}
body.toc2.toc-right #toc.toc2{border-right-width:0;border-left:1px solid #e7e7e9;left:auto;right:0}}
@media screen and (min-width:1280px){body.toc2{padding-left:20em;padding-right:0}
#toc.toc2{width:20em}
#toc.toc2 #toctitle{font-size:1.375em}
#toc.toc2>ul{font-size:.95em}
#toc.toc2 ul ul{padding-left:1.25em}
body.toc2.toc-right{padding-left:0;padding-right:20em}}
#content #toc{border-style:solid;border-width:1px;border-color:#e0e0dc;margin-bottom:1.25em;padding:1.25em;background:#f8f8f7;-webkit-border-radius:4px;border-radius:4px}
#content #toc>:first-child{margin-top:0}
#content #toc>:last-child{margin-bottom:0}
#footer{max-width:100%;background-color:rgba(0,0,0,.8);padding:1.25em}
#footer-text{color:rgba(255,255,255,.8);line-height:1.44}
#content{margin-bottom:.625em}
.sect1{padding-bottom:.625em}
@media screen and (min-width:768px){#content{margin-bottom:1.25em}
.sect1{padding-bottom:1.25em}}
.sect1:last-child{padding-bottom:0}
.sect1+.sect1{border-top:1px solid #e7e7e9}
#content h1>a.anchor,h2>a.anchor,h3>a.anchor,#toctitle>a.anchor,.sidebarblock>.content>.title>a.anchor,h4>a.anchor,h5>a.anchor,h6>a.anchor{position:absolute;z-index:1001;width:1.5ex;margin-left:-1.5ex;display:block;text-decoration:none!important;visibility:hidden;text-align:center;font-weight:400}
#content h1>a.anchor::before,h2>a.anchor::before,h3>a.anchor::before,#toctitle>a.anchor::before,.sidebarblock>.content>.title>a.anchor::before,h4>a.anchor::before,h5>a.anchor::before,h6>a.anchor::before{content:"\00A7";font-size:.85em;display:block;padding-top:.1em}
#content h1:hover>a.anchor,#content h1>a.anchor:hover,h2:hover>a.anchor,h2>a.anchor:hover,h3:hover>a.anchor,#toctitle:hover>a.anchor,.sidebarblock>.content>.title:hover>a.anchor,h3>a.anchor:hover,#toctitle>a.anchor:hover,.sidebarblock>.content>.title>a.anchor:hover,h4:hover>a.anchor,h4>a.anchor:hover,h5:hover>a.anchor,h5>a.anchor:hover,h6:hover>a.anchor,h6>a.anchor:hover{visibility:visible}
#content h1>a.link,h2>a.link,h3>a.link,#toctitle>a.link,.sidebarblock>.content>.title>a.link,h4>a.link,h5>a.link,h6>a.link{color:#ba3925;text-decoration:none}
#content h1>a.link:hover,h2>a.link:hover,h3>a.link:hover,#toctitle>a.link:hover,.sidebarblock>.content>.title>a.link:hover,h4>a.link:hover,h5>a.link:hover,h6>a.link:hover{color:#a53221}
.audioblock,.imageblock,.literalblock,.listingblock,.stemblock,.videoblock{margin-bottom:1.25em}
.admonitionblock td.content>.title,.audioblock>.title,.exampleblock>.title,.imageblock>.title,.listingblock>.title,.literalblock>.title,.stemblock>.title,.openblock>.title,.paragraph>.title,.quoteblock>.title,table.tableblock>.title,.verseblock>.title,.videoblock>.title,.dlist>.title,.olist>.title,.ulist>.title,.qlist>.title,.hdlist>.title{text-rendering:optimizeLegibility;text-align:left;font-family:"Noto Serif","DejaVu Serif",serif;font-size:1rem;font-style:italic}
table.tableblock.fit-content>caption.title{white-space:nowrap;width:0}
.paragraph.lead>p,#preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:1.21875em;line-height:1.6;color:rgba(0,0,0,.85)}
table.tableblock #preamble>.sectionbody>[class="paragraph"]:first-of-type p{font-size:inherit}
.admonitionblock>table{border-collapse:separate;border:0;background:none;width:100%}
.admonitionblock>table td.icon{text-align:center;width:80px}
.admonitionblock>table td.icon img{max-width:none}
.admonitionblock>table td.icon .title{font-weight:bold;font-family:"Open Sans","DejaVu Sans",sans-serif;text-transform:uppercase}
.admonitionblock>table td.content{padding-left:1.125em;padding-right:1.25em;border-left:1px solid #dddddf;color:rgba(0,0,0,.6)}
.admonitionblock>table td.content>:last-child>:last-child{margin-bottom:0}
.exampleblock>.content{border-style:solid;border-width:1px;border-color:#e6e6e6;margin-bottom:1.25em;padding:1.25em;background:#fff;-webkit-border-radius:4px;border-radius:4px}
.exampleblock>.content>:first-child{margin-top:0}
.exampleblock>.content>:last-child{margin-bottom:0}
.sidebarblock{border-style:solid;border-width:1px;border-color:#e0e0dc;margin-bottom:1.25em;padding:1.25em;background:#f8f8f7;-webkit-border-radius:4px;border-radius:4px}
.sidebarblock>:first-child{margin-top:0}
.sidebarblock>:last-child{margin-bottom:0}
.sidebarblock>.content>.title{color:#7a2518;margin-top:0;text-align:center}
.exampleblock>.content>:last-child>:last-child,.exampleblock>.content .olist>ol>li:last-child>:last-child,.exampleblock>.content .ulist>ul>li:last-child>:last-child,.exampleblock>.content .qlist>ol>li:last-child>:last-child,.sidebarblock>.content>:last-child>:last-child,.sidebarblock>.content .olist>ol>li:last-child>:last-child,.sidebarblock>.content .ulist>ul>li:last-child>:last-child,.sidebarblock>.content .qlist>ol>li:last-child>:last-child{margin-bottom:0}
.literalblock pre,.listingblock pre:not(.highlight),.listingblock pre[class="highlight"],.listingblock pre[class^="highlight "],.listingblock pre.CodeRay,.listingblock pre.prettyprint{background:#f7f7f8}
.sidebarblock .literalblock pre,.sidebarblock .listingblock pre:not(.highlight),.sidebarblock .listingblock pre[class="highlight"],.sidebarblock .listingblock pre[class^="highlight "],.sidebarblock .listingblock pre.CodeRay,.sidebarblock .listingblock pre.prettyprint{background:#f2f1f1}
.literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{-webkit-border-radius:4px;border-radius:4px;word-wrap:break-word;overflow-x:auto;padding:1em;font-size:.8125em}
@media screen and (min-width:768px){.literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{font-size:.90625em}}
@media screen and (min-width:1280px){.literalblock pre,.literalblock pre[class],.listingblock pre,.listingblock pre[class]{font-size:1em}}
.literalblock pre.nowrap,.literalblock pre.nowrap pre,.listingblock pre.nowrap,.listingblock pre.nowrap pre{white-space:pre;word-wrap:normal}
.literalblock.output pre{color:#f7f7f8;background-color:rgba(0,0,0,.9)}
.listingblock pre.highlightjs{padding:0}
.listingblock pre.highlightjs>code{padding:1em;-webkit-border-radius:4px;border-radius:4px}
.listingblock pre.prettyprint{border-width:0}
.listingblock>.content{position:relative}
.listingblock code[data-lang]::before{display:none;content:attr(data-lang);position:absolute;font-size:.75em;top:.425rem;right:.5rem;line-height:1;text-transform:uppercase;color:#999}
.listingblock:hover code[data-lang]::before{display:block}
.listingblock.terminal pre .command::before{content:attr(data-prompt);padding-right:.5em;color:#999}
.listingblock.terminal pre .command:not([data-prompt])::before{content:"$"}
table.pyhltable{border-collapse:separate;border:0;margin-bottom:0;background:none}
table.pyhltable td{vertical-align:top;padding-top:0;padding-bottom:0;line-height:1.45}
table.pyhltable td.code{padding-left:.75em;padding-right:0}
pre.pygments .lineno,table.pyhltable td:not(.code){color:#999;padding-left:0;padding-right:.5em;border-right:1px solid #dddddf}
pre.pygments .lineno{display:inline-block;margin-right:.25em}
table.pyhltable .linenodiv{background:none!important;padding-right:0!important}
.quoteblock{margin:0 1em 1.25em 1.5em;display:table}
.quoteblock>.title{margin-left:-1.5em;margin-bottom:.75em}
.quoteblock blockquote,.quoteblock p{color:rgba(0,0,0,.85);font-size:1.15rem;line-height:1.75;word-spacing:.1em;letter-spacing:0;font-style:italic;text-align:justify}
.quoteblock blockquote{margin:0;padding:0;border:0}
.quoteblock blockquote::before{content:"\201c";float:left;font-size:2.75em;font-weight:bold;line-height:.6em;margin-left:-.6em;color:#7a2518;text-shadow:0 1px 2px rgba(0,0,0,.1)}
.quoteblock blockquote>.paragraph:last-child p{margin-bottom:0}
.quoteblock .attribution{margin-top:.75em;margin-right:.5ex;text-align:right}
.verseblock{margin:0 1em 1.25em}
.verseblock pre{font-family:"Open Sans","DejaVu Sans",sans;font-size:1.15rem;color:rgba(0,0,0,.85);font-weight:300;text-rendering:optimizeLegibility}
.verseblock pre strong{font-weight:400}
.verseblock .attribution{margin-top:1.25rem;margin-left:.5ex}
.quoteblock .attribution,.verseblock .attribution{font-size:.9375em;line-height:1.45;font-style:italic}
.quoteblock .attribution br,.verseblock .attribution br{display:none}
.quoteblock .attribution cite,.verseblock .attribution cite{display:block;letter-spacing:-.025em;color:rgba(0,0,0,.6)}
.quoteblock.abstract blockquote::before,.quoteblock.excerpt blockquote::before,.quoteblock .quoteblock blockquote::before{display:none}
.quoteblock.abstract blockquote,.quoteblock.abstract p,.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{line-height:1.6;word-spacing:0}
.quoteblock.abstract{margin:0 1em 1.25em;display:block}
.quoteblock.abstract>.title{margin:0 0 .375em;font-size:1.15em;text-align:center}
.quoteblock.excerpt,.quoteblock .quoteblock{margin:0 0 1.25em;padding:0 0 .25em 1em;border-left:.25em solid #dddddf}
.quoteblock.excerpt blockquote,.quoteblock.excerpt p,.quoteblock .quoteblock blockquote,.quoteblock .quoteblock p{color:inherit;font-size:1.0625rem}
.quoteblock.excerpt .attribution,.quoteblock .quoteblock .attribution{color:inherit;text-align:left;margin-right:0}
table.tableblock{max-width:100%;border-collapse:separate}
p.tableblock:last-child{margin-bottom:0}
td.tableblock>.content{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
table.stripes-all tr,table.stripes-odd tr:nth-of-type(odd){background:#f8f8f7}
table.stripes-none tr,table.stripes-odd tr:nth-of-type(even){background:none}
th.halign-left,td.halign-left{text-align:left}
th.halign-right,td.halign-right{text-align:right}
th.halign-center,td.halign-center{text-align:center}
th.valign-top,td.valign-top{vertical-align:top}
th.valign-bottom,td.valign-bottom{vertical-align:bottom}
th.valign-middle,td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6;background:#f7f8f7}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{color:rgba(0,0,0,.8);font-weight:bold}
p.tableblock>code:only-child{background:none;padding:0}
p.tableblock{font-size:1em}
td>div.verse{white-space:pre}
ol{margin-left:1.75em}
ul li ol{margin-left:1.5em}
dl dd{margin-left:1.125em}
dl dd:last-child,dl dd:last-child>:last-child{margin-bottom:0}
ol>li p,ul>li p,ul dd,ol dd,.olist .olist,.ulist .ulist,.ulist .olist,.olist .ulist{margin-bottom:.625em}
ul.checklist,ul.none,ol.none,ul.no-bullet,ol.no-bullet,ol.unnumbered,ul.unstyled,ol.unstyled{list-style-type:none}
ul.no-bullet,ol.no-bullet,ol.unnumbered{margin-left:.625em}
ul.unstyled,ol.unstyled{margin-left:0}
ul.checklist{margin-left:.625em}
ul.checklist li>p:first-child>.fa-square-o:first-child,ul.checklist li>p:first-child>.fa-check-square-o:first-child{width:1.25em;font-size:.8em;position:relative;bottom:.125em}
ul.checklist li>p:first-child>input[type="checkbox"]:first-child{margin-right:.25em}
ul.inline{display:-ms-flexbox;display:-webkit-box;display:flex;-ms-flex-flow:row wrap;-webkit-flex-flow:row wrap;flex-flow:row wrap;list-style:none;margin:0 0 .625em -1.25em}
ul.inline>li{margin-left:1.25em}
.unstyled dl dt{font-weight:400;font-style:normal}
ol.arabic{list-style-type:decimal}
ol.decimal{list-style-type:decimal-leading-zero}
ol.loweralpha{list-style-type:lower-alpha}
ol.upperalpha{list-style-type:upper-alpha}
ol.lowerroman{list-style-type:lower-roman}
ol.upperroman{list-style-type:upper-roman}
ol.lowergreek{list-style-type:lower-greek}
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
.literalblock+.colist,.listingblock+.colist{margin-top:-.5em}
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}
.thumb,.th{line-height:0;display:inline-block;border:solid 4px #fff;-webkit-box-shadow:0 0 0 1px #ddd;box-shadow:0 0 0 1px #ddd}
.imageblock.left{margin:.25em .625em 1.25em 0}
.imageblock.right{margin:.25em 0 1.25em .625em}
.imageblock>.title{margin-bottom:0}
.imageblock.thumb,.imageblock.th{border-width:6px}
.imageblock.thumb>.title,.imageblock.th>.title{padding:0 .125em}
.image.left,.image.right{margin-top:.25em;margin-bottom:.25em;display:inline-block;line-height:0}
.image.left{margin-right:.625em}
.image.right{margin-left:.625em}
a.image{text-decoration:none;display:inline-block}
a.image object{pointer-events:none}
sup.footnote,sup.footnoteref{font-size:.875em;position:static;vertical-align:super}
sup.footnote a,sup.footnoteref a{text-decoration:none}
sup.footnote a:active,sup.footnoteref a:active{text-decoration:underline}
#footnotes{padding-top:.75em;padding-bottom:.75em;margin-bottom:.625em}
#footnotes hr{width:20%;min-width:6.25em;margin:-.25em 0 .75em;border-width:1px 0 0}
#footnotes .footnote{padding:0 .375em 0 .225em;line-height:1.3334;font-size:.875em;margin-left:1.2em;margin-bottom:.2em}
#footnotes .footnote a:first-of-type{font-weight:bold;text-decoration:none;margin-left:-1.05em}
#footnotes .footnote:last-of-type{margin-bottom:0}
#content #footnotes{margin-top:-.625em;margin-bottom:0;padding:.75em 0}
.gist .file-data>table{border:0;background:#fff;width:100%;margin-bottom:0}
.gist .file-data>table td.line-data{width:99%}
div.unbreakable{page-break-inside:avoid}
.big{font-size:larger}
.small{font-size:smaller}
.underline{text-decoration:underline}
.overline{text-decoration:overline}
.line-through{text-decoration:line-through}
.aqua{color:#00bfbf}
.aqua-background{background-color:#00fafa}
.black{color:#000}
.black-background{background-color:#000}
.blue{color:#0000bf}
.blue-background{background-color:#0000fa}
.fuchsia{color:#bf00bf}
.fuchsia-background{background-color:#fa00fa}
.gray{color:#606060}
.gray-background{background-color:#7d7d7d}
.green{color:#006000}
.green-background{background-color:#007d00}
.lime{color:#00bf00}
.lime-background{background-color:#00fa00}
.maroon{color:#600000}
.maroon-background{background-color:#7d0000}
.navy{color:#000060}
.navy-background{background-color:#00007d}
.olive{color:#606000}
.olive-background{background-color:#7d7d00}
.purple{color:#600060}
.purple-background{background-color:#7d007d}
.red{color:#bf0000}
.red-background{background-color:#fa0000}
.silver{color:#909090}
.silver-background{background-color:#bcbcbc}
.teal{color:#006060}
.teal-background{background-color:#007d7d}
.white{color:#bfbfbf}
.white-background{background-color:#fafafa}
.yellow{color:#bfbf00}
.yellow-background{background-color:#fafa00}
span.icon>.fa{cursor:default}
a span.icon>.fa{cursor:inherit}
.admonitionblock td.icon [class^="fa icon-"]{font-size:2.5em;text-shadow:1px 1px 2px rgba(0,0,0,.5);cursor:default}
.admonitionblock td.icon .icon-note::before{content:"\f05a";color:#19407c}
.admonitionblock td.icon .icon-tip::before{content:"\f0eb";text-shadow:1px 1px 2px rgba(155,155,0,.8);color:#111}
.admonitionblock td.icon .icon-warning::before{content:"\f071";color:#bf6900}
.admonitionblock td.icon .icon-caution::before{content:"\f06d";color:#bf3400}
.admonitionblock td.icon .icon-important::before{content:"\f06a";color:#bf0000}
.conum[data-value]{display:inline-block;color:#fff!important;background-color:rgba(0,0,0,.8);-webkit-border-radius:100px;border-radius:100px;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]::after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
dt,th.tableblock,td.content,div.footnote{text-rendering:optimizeLegibility}
h1,h2,p,td.content,span.alt{letter-spacing:-.01em}
p strong,td.content strong,div.footnote strong{letter-spacing:-.005em}
p,blockquote,dt,td.content,span.alt{font-size:1.0625rem}
p{margin-bottom:1.25rem}
.sidebarblock p,.sidebarblock dt,.sidebarblock td.content,p.tableblock{font-size:1em}
.exampleblock>.content{background-color:#fffef7;border-color:#e0e0dc;-webkit-box-shadow:0 1px 4px #e0e0dc;box-shadow:0 1px 4px #e0e0dc}
.print-only{display:none!important}
@page{margin:1.25cm .75cm}
@media print{*{-webkit-box-shadow:none!important;box-shadow:none!important;text-shadow:none!important}
html{font-size:80%}
a{color:inherit!important;text-decoration:underline!important}
a.bare,a[href^="#"],a[href^="mailto:"]{text-decoration:none!important}
a[href^="http:"]:not(.bare)::after,a[href^="https:"]:not(.bare)::after{content:"(" attr(href) ")";display:inline-block;font-size:.875em;padding-left:.25em}
abbr[title]::after{content:" (" attr(title) ")"}
pre,blockquote,tr,img,object,svg{page-break-inside:avoid}
thead{display:table-header-group}
svg{max-width:100%}
p,blockquote,dt,td.content{font-size:1em;orphans:3;widows:3}
h2,h3,#toctitle,.sidebarblock>.content>.title{page-break-after:avoid}
#toc,.sidebarblock,.exampleblock>.content{background:none!important}
#toc{border-bottom:1px solid #dddddf!important;padding-bottom:0!important}
body.book #header{text-align:center}
body.book #header>h1:first-child{border:0!important;margin:2.5em 0 1em}
body.book #header .details{border:0!important;display:block;padding:0!important}
body.book #header .details span:first-child{margin-left:0!important}
body.book #header .details br{display:block}
body.book #header .details br+span::before{content:none!important}
body.book #toc{border:0!important;text-align:left!important;padding:0!important;margin:0!important}
body.book #toc,body.book #preamble,body.book h1.sect0,body.book .sect1>h2{page-break-before:always}
.listingblock code[data-lang]::before{display:block}
#footer{padding:0 .9375em}
.hide-on-print{display:none!important}
.print-only{display:block!important}
.hide-for-print{display:none!important}
.show-for-print{display:inherit!important}}
@media print,amzn-kf8{#header>h1:first-child{margin-top:1.25rem}
.sect1{padding:0!important}
.sect1+.sect1{border:0}
#footer{background:none}
#footer-text{color:rgba(0,0,0,.6);font-size:.9em}}
@media amzn-kf8{#header,#content,#footnotes,#footer{padding:0}}
</style>
</head>
<body class="article toc2 toc-left">
<div id="header">
<h1>Leadium Framework</h1>
<div id="toc" class="toc2">
<div id="toctitle">Table of Contents</div>
<ul class="sectlevel1">
<li><a href="#_общее_описание_проекта">Общее описание проекта</a></li>
<li><a href="#_установка_окружения">Установка окружения</a>
<ul class="sectlevel2">
<li><a href="#_allure">Allure</a></li>
<li><a href="#_docker">Docker</a></li>
<li><a href="#_selenoid">Selenoid</a></li>
</ul>
</li>
<li><a href="#_как_начать">Как начать</a>
<ul class="sectlevel2">
<li><a href="#_подготовка_проекта">Подготовка проекта</a></li>
<li><a href="#_создание_модуля">Создание модуля</a></li>
<li><a href="#_создание_теста">Создание теста</a></li>
</ul>
</li>
<li><a href="#_локальный_запуск_тестов">Локальный запуск тестов</a>
<ul class="sectlevel2">
<li><a href="#_запуск_тестов_из_intellij_idea">Запуск тестов из Intellij Idea</a></li>
<li><a href="#_запуск_тестов_из_консоли">Запуск тестов из консоли</a></li>
<li><a href="#_формирование_allure_отчета">Формирование allure-отчета</a></li>
</ul>
</li>
<li><a href="#_параллельный_запуск_тестов">Параллельный запуск тестов</a></li>
<li><a href="#_для_изучения">Для изучения</a>
<ul class="sectlevel2">
<li><a href="#_структура">Структура</a></li>
<li><a href="#_конфигурационные_файлы">Конфигурационные файлы</a></li>
<li><a href="#_основные_классы_и_их_методы">Основные классы и их методы</a></li>
<li><a href="#_локаторы">Локаторы</a></li>
<li><a href="#_рекомендации">Рекомендации</a></li>
</ul>
</li>
</ul>
</div>
</div>
<div id="content">
<div class="sect1">
<h2 id="_общее_описание_проекта">Общее описание проекта</h2>
<div class="sectionbody">
<div class="paragraph">
<p>Проект разрабатывается с декабря 2017 года.
Он предназначен для написания автотестов на базе Selenium и в частности покрытия ими процессов пакетного решения для банковских систем Appian BPM.</p>
</div>
<div class="paragraph">
<p>При написании авто-тестов, с использованием leadium framework, важно соблюдать структуру проекта и очередность действий изложенных в данном мануале.</p>
</div>
<div class="paragraph">
<p>Это позволит:</p>
</div>
<div class="ulist">
<ul>
<li>
<p>Использовать лучшие инструменты для автоматизации веб UI тестирования</p>
</li>
<li>
<p>Создать масштабируемый проект, для разработки, отладки и запуска авто-тестов</p>
</li>
<li>
<p>Совместно разрабатывать авто-тесты без засорения пространства имен, благодаря многомодульности проекта</p>
</li>
<li>
<p>Писать максимально гибкие и легко читаемые сценарии тестов на языке kotlin</p>
</li>
<li>
<p>Получить подробный отчет по итогу прогона с такими вложениями как</p>
<div class="ulist">
<ul>
<li>
<p>тестовые значения</p>
</li>
<li>
<p>скриншоты</p>
</li>
<li>
<p>видео</p>
</li>
<li>
<p>json</p>
</li>
<li>
<p>текстовые документы</p>
</li>
<li>
<p>запросы и ответы при работе с бд или апи</p>
</li>
</ul>
</div>
</li>
<li>
<p>Запускать тесты параллельно в docker-контейнерах с записью видео в каждом потоке</p>
</li>
</ul>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_установка_окружения">Установка окружения</h2>
<div class="sectionbody">
<div class="ulist">
<ul>
<li>
<p>Для работы с проектом устанавливаем <a href="https://www.jetbrains.com/idea/download">Intellij IDEA</a></p>
</li>
<li>
<p>Для запуска тестов устанавливаем <a href="https://gradle.org/install">Gradle</a></p>
</li>
</ul>
</div>
<div class="sect2">
<h3 id="_allure">Allure</h3>
<div class="paragraph">
<p>Чтобы скачать allure:</p>
</div>
<div class="ulist">
<ul>
<li>
<p><a href="https://github.com/allure-framework/allure2/releases" class="bare">https://github.com/allure-framework/allure2/releases</a></p>
</li>
</ul>
</div>
</div>
<div class="sect2">
<h3 id="_docker">Docker</h3>
<div class="paragraph">
<p>Для запуска тестов в контейнерах устанавливаем docker:</p>
</div>
<div class="ulist">
<ul>
<li>
<p><a href="https://www.docker.com/get-started" class="bare">https://www.docker.com/get-started</a></p>
</li>
</ul>
</div>
<div class="paragraph">
<p>скачать образы docker:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code>docker pull selenoid/video-recorder
docker pull selenoid/vnc:chrome_65.0</code></pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_selenoid">Selenoid</h3>
<div class="paragraph">
<p>Бинарники Selenoid&#8217;a можно скачать тут:</p>
</div>
<div class="ulist">
<ul>
<li>
<p><a href="https://github.com/aerokube/selenoid-ui/releases" class="bare">https://github.com/aerokube/selenoid-ui/releases</a></p>
</li>
<li>
<p><a href="https://github.com/aerokube/selenoid/releases" class="bare">https://github.com/aerokube/selenoid/releases</a></p>
</li>
</ul>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_как_начать">Как начать</h2>
<div class="sectionbody">
<div class="sect2">
<h3 id="_подготовка_проекта">Подготовка проекта</h3>
<div class="ulist">
<ul>
<li>
<p>Заполняем dependencies в build.gradle указывая актуальные версии:</p>
</li>
</ul>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-groovy" data-lang="groovy">dependencies {
    compile files('filefinder.jar')
    compile fileTree(dir: 'libs', include: ['*.jar'])

    compile "org.jetbrains.kotlin:kotlin-stdlib:1.3.11"
    implementation "org.jetbrains.kotlinx:kotlinx-coroutines-core:1.0.1"

    testCompile("org.junit.jupiter:junit-jupiter-api:5.3.2")
    testRuntime("org.junit.jupiter:junit-jupiter-engine:5.3.2")

    testCompile group: 'io.rest-assured', name: 'rest-assured', version: '3.1.1'
    compile group: 'mysql', name: 'mysql-connector-java', version: '8.0.12'

    compile group: 'io.qameta.allure', name: 'allure-junit5', version: '2.9.0'
    compile group: 'io.qameta.allure', name: 'allure-java-commons', version: '2.9.0'

    compile group: 'com.codeborne', name: 'selenide', version: '5.0.1'
    compile group: 'org.json', name: 'json', version: '20180813' // edit json

    // video recorder / encoder
    compile group: 'com.automation-remarks', name: 'video-recorder-core', version: '1.7'
    compile group: 'com.automation-remarks', name: 'video-recorder-junit', version: '1.7'
    compile group: 'net.bramp.ffmpeg', name: 'ffmpeg', version: '0.6.2'
}</code></pre>
</div>
</div>
<div class="ulist">
<ul>
<li>
<p>Модифицируем таски с типом Test</p>
</li>
</ul>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-groovy" data-lang="groovy">tasks.withType(Test) {
    useJUnitPlatform()
    testLogging {
        events("passed", "skipped", "failed")
    }
    systemProperty "host", System.getProperty("host", "qa")
    systemProperty "containers", System.getProperty("containers", "false")
}</code></pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_создание_модуля">Создание модуля</h3>
<div class="paragraph">
<p>Для покрытия процесса автотестами первым делом создаем директорию в src/test/sources/apps
c названием тестируемого процесса в которой создаем 2 директории “source” и “resources”, затем создаем отдельный kotlin-модуль для этого процесса:</p>
</div>
<div class="paragraph">
<p>File &#8594; Project Structure &#8594; Modules &#8594; Add &#8594; New Module &#8594; Kotlin/JVM &#8594; Next  &#8594; Создаем и выбираем ранее созданную директорию для Content root &#8594; FInish &#8594; Настраиваем вкладки Sources и Dependencies по подобию уже созданных тестовых модулей. (на вкладке Sources директорию source пометить как Test, resources как Test Resources, src удалить)</p>
</div>
<div class="sidebarblock">
<div class="content">
<div class="paragraph">
<p>Более быстрым способом будет скопировать уже существующий модуль изменив название и путь к соответвующей директории</p>
</div>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_создание_теста">Создание теста</h3>
<div class="paragraph">
<p>Далее в директории “source” создаем одноименную с модулем директорию (для корректной структуры packages) в которой создаются директории “cases”, “substeps”, “suite” и опционально “data”.</p>
</div>
<div class="paragraph">
<p>Нажимаем правой кнопкой мыши на “cases” и выбираем  New &#8594; Kotlin FIle/Class, вводим имя тестового класса, затем Ok. В созданном файле объявим класс, который имплементирует TestActions и создадим метод begin. Теперь все готово для написания тестового сценария. Подшаги сценариев хранятся в директории “substeps”</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-kotlin" data-lang="kotlin">class NewTest : TestActions { // <b class="conum">(1)</b>

   companion object { // <b class="conum">(2)</b>
       val cifInput get() = AppianElements.input("Cif Number") // <b class="conum">(3)</b>
       val cityDropdown get() = AppianElements.dropdown("City") // <b class="conum">(4)</b>
   }

   fun begin(name: String,
             cif: String,
             city: String) { // <b class="conum">(5)</b>

       "New Customer Form" shouldBe visible
       name shouldBe visible
       cifInput set cif
       cityDropdown..city
       "Submit".."Yes"
       "New Customer Form" shouldBe hidden
   }
}</code></pre>
</div>
</div>
<div class="colist arabic">
<ol>
<li>
<p>Имплементируем TestActions</p>
</li>
<li>
<p>Указываем элементы с которыми производим тестирование</p>
</li>
<li>
<p>Не забываем указывать что это геттер get()</p>
</li>
<li>
<p>Для облегчения зрительного восприятия тесткейса, этот объект с элементами и действия над ними вынесем в отдельный сабстеп</p>
</li>
<li>
<p>Указываем параметры для тестовых значений</p>
</li>
</ol>
</div>
<hr>
<div class="paragraph">
<p>Для облегчения зрительного восприятия тест-кейса, companion object с элементами и действия над ними вынесем в отдельный саб-степ</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-kotlin" data-lang="kotlin">class NewSubstep(cif: String?,
                city: String?) : TestActions {

   companion object {
       val cifInput get() = AppianElements.input("Cif Number")
       val cityDropdown get() = AppianElements.dropdown("City")
   }

   init {
       begin("Filling Customer Form") { // <b class="conum">(1)</b>
           cif?.let { cifInput set cif }
           city?.let { cityDropdown..city }
       }
   }
}</code></pre>
</div>
</div>
<div class="colist arabic">
<ol>
<li>
<p>Сабстепы пишем в begin("Название подшага для allure")</p>
</li>
</ol>
</div>
<hr>
<div class="paragraph">
<p>В облегченном варианте тест-кейс будет выглядеть следующим образом:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-kotlin" data-lang="kotlin">class NewTest : TestActions {

   fun begin(name: String,
             cif: String,
             city: String) {

       "New Customer Form" shouldBe visible
       name shouldBe visible
       NewSubstep(cif, city) // <b class="conum">(1)</b>
       "Submit".."Yes"
       "New Customer Form" shouldBe hidden
   }
}</code></pre>
</div>
</div>
<div class="colist arabic">
<ol>
<li>
<p>Наш сабстеп</p>
</li>
</ol>
</div>
<hr>
<div class="paragraph">
<p>Теперь созданный тест-кейс необходимо внести в набор, который создадим в директории “suite”</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-kotlin" data-lang="kotlin">@Epic("NEW") // <b class="conum">(1)</b>
class NewSuite : JunitTest() { // <b class="conum">(2)</b>

   @BeforeEach
   override fun beforeEach() { // <b class="conum">(3)</b>
       super.beforeEach()
       with(AuthProperties) { // <b class="conum">(4)</b>
           SignIn(login, pass)
       }
   }

   @Test // <b class="conum">(5)</b>
   @Feature("POSITIVE") // <b class="conum">(6)</b>
   @DisplayName("filling customer form | positive") // <b class="conum">(7)</b>
   fun fillingCustomerForm() {
       val test = newprocess.cases.NewTest() // <b class="conum">(8)</b>
       val values = initValues("values/newprocess/cases/NewTest.property") // <b class="conum">(9)</b>
       test.begin( // <b class="conum">(10)</b>
               values["name"],
               values["cif"],
               values["city"]) // <b class="conum">(11)</b>
   }
}</code></pre>
</div>
</div>
<div class="colist arabic">
<ol>
<li>
<p>Обозначение основной группы в allure-отчете</p>
</li>
<li>
<p>Наследуемся от JunitTest()</p>
</li>
<li>
<p>В этом методе происходит вход пользователя перед каждым тестом</p>
</li>
<li>
<p>Чтобы поменять пользователя, достаточно указать его после AuthProperties, например: with(AuthProperties.Teller) {&#8230;&#8203;}</p>
</li>
<li>
<p>Пометим, что данный метод является тестом</p>
</li>
<li>
<p>Подгруппа для allure-отчета</p>
</li>
<li>
<p>Отображаемое имя в allure-отчете</p>
</li>
<li>
<p>Создаем экземпляр тесткейса</p>
</li>
<li>
<p>Инициализируем тестовые значения из ресурсов проекта. В метод initValues() так же встроено прикрепление всех значений в description отчета.</p>
</li>
<li>
<p>Запуск прохождения теста</p>
</li>
<li>
<p>Производим маппинг значений и передаем их в кач-ве аргументов</p>
</li>
</ol>
</div>
<hr>
<div class="paragraph">
<p>Теперь можем запустить тесты и увидеть результат прогона.</p>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_локальный_запуск_тестов">Локальный запуск тестов</h2>
<div class="sectionbody">
<div class="sect2">
<h3 id="_запуск_тестов_из_intellij_idea">Запуск тестов из Intellij Idea</h3>
<div class="paragraph">
<p>Для запуска тестов из Intellij Idea достотачно нажать Run в тестовом классе.</p>
</div>
</div>
<div class="sect2">
<h3 id="_запуск_тестов_из_консоли">Запуск тестов из консоли</h3>
<div class="paragraph">
<p>Для запуска тестов из консоли пропишем:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code>gradle -Dcontainers=false test --tests "reference.to.TestClass" -i</code></pre>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_формирование_allure_отчета">Формирование allure-отчета</h3>
<div class="paragraph">
<p>Для того чтобы в allure-отчете разделить тесты по категориям, нужно поместить categories.json в resources основного модуля, со следующим содержанием:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-json" data-lang="json">[
{
    "name": "Success tests",
    "matchedStatuses": ["passed"]
  },
{
    "name": "Test defects",
    "matchedStatuses": ["broken"]
  },
{
    "name": "Product defects",
    "matchedStatuses": ["failed"]
  },
{
    "name": "Skipped tests",
    "matchedStatuses": ["skipped"]
  }
]</code></pre>
</div>
</div>
<div class="paragraph">
<p>Для того чтобы сформировать allure-отчет пропишем:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code>./allure serve /home/user/path/to/allure-results</code></pre>
</div>
</div>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_параллельный_запуск_тестов">Параллельный запуск тестов</h2>
<div class="sectionbody">
<div class="paragraph">
<p>создать docker network:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code>docker network create \
  --driver=bridge \
  --subnet=172.29.0.0/16 \
  --ip-range=172.29.5.0/24 \
  --gateway=172.29.5.254 \
  bridge1</code></pre>
</div>
</div>
<div class="paragraph">
<p>Перед запуском тестов, запустим selenoid и selenoid-ui из selenoid директории проекта:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code>./selenoid -limit 4 -container-network bridge1
./selenoid-ui -listen :8090</code></pre>
</div>
</div>
<div class="paragraph">
<p>Для запуска набора:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code>gradle -Dhost=qa -Dcontainers=true test --tests “newprocess.suite.NewSuite” -i</code></pre>
</div>
</div>
<div class="ulist">
<ul>
<li>
<p>-Dhost для указания стенда на котором произвести тестирование</p>
</li>
<li>
<p>-Dcontainers для запуска в контейнерах</p>
</li>
<li>
<p>--tests “newprocess.suite.NewSuite” указываем актуальный reference тестового набора, который запустить</p>
</li>
</ul>
</div>
</div>
</div>
<div class="sect1">
<h2 id="_для_изучения">Для изучения</h2>
<div class="sectionbody">
<div class="ulist">
<ul>
<li>
<p><a href="https://junit.org/junit5/docs/current/user-guide">Ознакомиться с основами Junit5</a></p>
</li>
<li>
<p><a href="https://selenide.gitbooks.io/user-guide/content/ru">Изучить полностью документацию Selenide</a></p>
</li>
<li>
<p><a href="https://www.swtestacademy.com/xpath-selenium">How to Write Effective XPath Selenium Selectors</a></p>
</li>
<li>
<p><a href="https://kotlinlang.ru/docs">Ознакомиться с основами языка Kotlin</a></p>
</li>
</ul>
</div>
<div class="sect2">
<h3 id="_структура">Структура</h3>
<div class="sect3">
<h4 id="_структура_ядра">Структура ядра</h4>
<div class="imageblock">
<div class="content">
<img src="pics/structure-core.png" alt="structure core">
</div>
</div>
<div class="paragraph">
<p>core.jar помещаем в папку libs в корне проекта</p>
</div>
<div class="paragraph">
<p>в build.gradle в блоке dependencies пропишем:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-groovy" data-lang="groovy">dependencies {
    ...
    compile fileTree(dir: 'libs', include: ['*.jar'])
    ...
}</code></pre>
</div>
</div>
</div>
<div class="sect3">
<h4 id="_file_finder">File Finder</h4>
<div class="paragraph">
<p>Для поиска файлов в проекте мы используем filefinder.jar он содержит класс FileFinder с одним методом поиска byEndOfPath.
filefinder.jar обязательно должен находиться в корне проекта, чтобы иметь возможность вести поиск начиная с корневой директории.</p>
</div>
<div class="paragraph">
<p>в build.gradle в блоке dependencies пропишем:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-groovy" data-lang="groovy">dependencies {
    ...
    compile files('filefinder.jar')
    ...
}</code></pre>
</div>
</div>
<div class="paragraph">
<p>В конструкторе мы можем (но не обязательно) уточнить путь после корневого с которого начинать поиск, а в методе byEndOfPath укажем только уникальную часть с конца пути к файлу.
После выполнения этот метод вернет File для последующей работы с ним.</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-kotlin" data-lang="kotlin">val file = FileFinder("/src/test") byEndOfPath "/img/temp.png"</code></pre>
</div>
</div>
<div class="paragraph">
<p>File Finder позволяет:</p>
</div>
<div class="ulist">
<ul>
<li>
<p>Получать файлы не только из working directory, а со всего проекта.
Например в случае если gradle-проект содержит вложенные idea-модули из которых производится run тестов через ide - при стандартных методах получения файлов, в такой ситуации, мы не сможем получить ресурсы из корневого gradle-модуля, а только ресурсы вложенного idea-модуля из которого производится запуск тестов.</p>
</li>
<li>
<p>Указывать относительный путь вместо абсолютного для получения файлов.</p>
</li>
</ul>
</div>
</div>
<div class="sect3">
<h4 id="_структура_проекта">Структура проекта</h4>
<div class="imageblock">
<div class="content">
<img src="pics/structure.png" alt="structure">
</div>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_конфигурационные_файлы">Конфигурационные файлы</h3>
<div class="sect3">
<h4 id="_init_property">init.property</h4>
<div class="paragraph lead">
<p>(настройки selenide)</p>
</div>
<div class="dlist">
<dl>
<dt class="hdlist1">highlighterEnabled=true</dt>
<dd>
<p>подсветка перед нажатием на элемент</p>
</dd>
<dt class="hdlist1">LogEventPrinterEnabled=true</dt>
<dd>
<p>печать логов в консоль</p>
</dd>
<dt class="hdlist1">savePageSource=false</dt>
<dd>
<p>сохранение html</p>
</dd>
<dt class="hdlist1">containers=true</dt>
<dd>
<p>запуск в контейнерах</p>
</dd>
<dt class="hdlist1">startMaximized=true</dt>
<dd>
<p>запуск в развернутом окне</p>
</dd>
<dt class="hdlist1">browser=chrome</dt>
<dd>
<p>выбор браузера</p>
</dd>
<dt class="hdlist1">timeout=30000</dt>
<dd>
<p>таймаут</p>
</dd>
<dt class="hdlist1">screenshots=false</dt>
<dd>
<p>автоматическое получение скриншотов</p>
</dd>
<dt class="hdlist1">headless=false</dt>
<dd>
<p>headless-режим</p>
</dd>
<dt class="hdlist1">driverManagerEnabled=true</dt>
<dd>
<p>включение драйвер-менеджера</p>
</dd>
<dt class="hdlist1">holdBrowserOpen=false</dt>
<dd>
<p>удержание браузера открытым</p>
</dd>
</dl>
</div>
<div class="sidebarblock">
<div class="content">
<div class="paragraph">
<p>Чтобы воспользоваться остальными настройками, достаточно дописать их в init.property в соответствии с <a href="https://selenide.org/javadoc/current/index.html?com/codeborne/selenide/Configuration.html">документацией конфигурации Selenide</a></p>
</div>
</div>
</div>
</div>
<div class="sect3">
<h4 id="_selenoid_property">selenoid.property</h4>
<div class="paragraph lead">
<p>(настройки selenoid)</p>
</div>
<div class="dlist">
<dl>
<dt class="hdlist1">browserName=chrome</dt>
<dd>
<p>выбор браузера для запуска в контейнере</p>
</dd>
<dt class="hdlist1">enableVNC=true</dt>
<dd>
<p>включение VNC</p>
</dd>
<dt class="hdlist1">enableVideo=true</dt>
<dd>
<p>включение записи видео</p>
</dd>
<dt class="hdlist1">localhost=http://localhost:4444</dt>
<dd>
<p>указание локального хоста и порта</p>
</dd>
<dt class="hdlist1">jenkins=http://our_jenkins_host.com:4444</dt>
<dd>
<p>указание хоста для дженкинса и порта</p>
</dd>
<dt class="hdlist1">dimension.width=1280</dt>
<dd>
<p>разрешение экрана - ширина</p>
</dd>
<dt class="hdlist1">dimension.height=1024</dt>
<dd>
<p>разрешение экрана - высота</p>
</dd>
</dl>
</div>
<div class="sidebarblock">
<div class="content">
<div class="paragraph">
<p>Полный список настроек можно увидеть в <a href="https://aerokube.com/selenoid/1.3.7/#_advanced_features">документации Selenoid</a></p>
</div>
</div>
</div>
</div>
<div class="sect3">
<h4 id="_video_property">video.property</h4>
<div class="paragraph lead">
<p>(локальная запись видео)</p>
</div>
<div class="dlist">
<dl>
<dt class="hdlist1">video.enabled=false</dt>
<dd>
<p>включение и выключение записи</p>
</dd>
<dt class="hdlist1">recorder.type=MONTE</dt>
<dd>
<p>кодек</p>
</dd>
<dt class="hdlist1">video.frame.rate=24</dt>
<dd>
<p>фрейм-рейт</p>
</dd>
<dt class="hdlist1">video.save.mode=FAILED_ONLY</dt>
<dd>
<p>режим сохранения видео</p>
</dd>
<dt class="hdlist1">video.folder=${user home}/video</dt>
<dd>
<p>директория сохранения видео</p>
</dd>
<dt class="hdlist1">video.mode=ALL</dt>
<dd>
<p>режим записи видео</p>
</dd>
</dl>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_основные_классы_и_их_методы">Основные классы и их методы</h3>
<div class="sect3">
<h4 id="_org_leadium_testaction">org.leadium.TestAction</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">open()</dt>
<dd>
<p>открытие браузера с отловом TimeoutException</p>
</dd>
<dt class="hdlist1">String.click() : SelenideElement</dt>
<dd>
<p>функция-расширение класса String для нажатия на веб-элемент, найденный по тексту, например: “Search”.click()</p>
</dd>
<dt class="hdlist1">String.shouldBe(condition) : SelenideElement</dt>
<dd>
<p>для проверки кондиций с ожиданием</p>
</dd>
<dt class="hdlist1">String.has(condition) : Boolean</dt>
<dd>
<p>для проверки кондиций без ожидания</p>
</dd>
<dt class="hdlist1">String.rangeTo(text)</dt>
<dd>
<p>перегрузка оператора “..” для последовательного нажатия по элементам, найденных по тексту, например: “Cancel”..”Yes”</p>
</dd>
<dt class="hdlist1">SelenideElement.rangeTo(text)</dt>
<dd>
<p>функция-расширение класса SelenideElement для последовательного нажатия на этот элемент и затем на элемент найденный по тексту, очень удобно для работы с dropdown, например: cityDropdown..”Moscow”</p>
</dd>
<dt class="hdlist1">SelenideElement.set(value) : SelenideElement</dt>
<dd>
<p>для заполнения input - элементов значением</p>
</dd>
<dt class="hdlist1">SelenideElement.sendKeys(key) : WebElement</dt>
<dd>
<p>отправка элементу сигнала о нажатии клавиши клавиатуры</p>
</dd>
<dt class="hdlist1">SelenideElement.shouldBe(condition) : SelenideElement</dt>
<dd>
<p>для проверки кондиций с ожиданием</p>
</dd>
<dt class="hdlist1">SelenideElement.has(text) : Boolean</dt>
<dd>
<p>для проверки наличия текста отображаемого элементом без ожидания</p>
</dd>
<dt class="hdlist1">SelenideElement.has(condition) : Boolean</dt>
<dd>
<p>для проверки кондиций без ожидания</p>
</dd>
<dt class="hdlist1">SelenideElement.upload(file) : SelenideElement</dt>
<dd>
<p>для загрузки файла в инпут</p>
</dd>
<dt class="hdlist1">moveTo(element) : SelenideElement</dt>
<dd>
<p>перемещает область экрана к указанному элементу</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_org_leadium_allure">org.leadium.allure</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">AllureFiles</dt>
<dd>
<p>работа со вспомогательными файлами для отчетов allure</p>
</dd>
<dt class="hdlist1">Attachment</dt>
<dd>
<p>прикрепление файлов различного типа к отчетам allure</p>
</dd>
<dt class="hdlist1">Highlighter</dt>
<dd>
<p>подсвечивание веб-элемента перед нажатием на него</p>
</dd>
<dt class="hdlist1">Marker</dt>
<dd>
<p>различные маркеры для подсветки веб-элементов</p>
</dd>
<dt class="hdlist1">ReportBuilder</dt>
<dd>
<p>парсер логов, билдер отчетов allure</p>
</dd>
<dt class="hdlist1">TitleProvider</dt>
<dd>
<p>интерфейс для пометки провайдера кастомных имен</p>
</dd>
<dt class="hdlist1">TitleReceiver</dt>
<dd>
<p>интерфейс для пометки приемника кастомных имен</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_org_leadium_allure_reportbuilder">org.leadium.allure.ReportBuilder</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">begin(title, steps)</dt>
<dd>
<p>метод для создания подшага в allure-отчете</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_org_leadium_utils">org.leadium.utils</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">Encoder</dt>
<dd>
<p>для конвертации видео файла</p>
</dd>
<dt class="hdlist1">NonNullMap</dt>
<dd>
<p>для централизованного отлова NPE при работе с map</p>
</dd>
<dt class="hdlist1">Random</dt>
<dd>
<p>для генерации случайной строки состоящей из цифр</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_base_appian">base.appian</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">AppianActions</dt>
<dd>
<p>общие тестовые действия для интерфейса appian</p>
</dd>
<dt class="hdlist1">AppianElements</dt>
<dd>
<p>содержит методы получения appian элементов по текстовому лейблу находящегося перед элементом, а также бинды общих элементов и коллекций элементов по тегу</p>
</dd>
<dt class="hdlist1">AppianEventListener</dt>
<dd>
<p>слушатель статуса “Working” интерфейса appian, нужен для динамического ожидания внутренних процессов системы</p>
</dd>
<dt class="hdlist1">AppianTable</dt>
<dd>
<p>экспериментальный конструктор для работы с таблицами</p>
</dd>
<dt class="hdlist1">LogEventPrinter</dt>
<dd>
<p>слушатель логов селенида, для последующей их фильтрации и печати в консоль</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_base_appian_appianactions">base.appian.AppianActions</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">SelenideElement.autocompleteEnter()</dt>
<dd>
<p>для своевременного нажатия enter после того как в autocomplete списке появились результаты поиска</p>
</dd>
<dt class="hdlist1">checkMilestone()</dt>
<dd>
<p>для проверки корректности отображаемого шага на milestone виджете</p>
</dd>
<dt class="hdlist1">clickAccept()</dt>
<dd>
<p>нажатие на accept если он видимый</p>
</dd>
<dt class="hdlist1">checkHoliday(dateString, format) : Boolean</dt>
<dd>
<p>парсинг и проверка входной строки с датой, что сегодня пятница или суббота</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_base_extensions">base.extensions</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">Allure</dt>
<dd>
<p>слушатель колбеков тестов для нужд allure</p>
</dd>
<dt class="hdlist1">Configuration</dt>
<dd>
<p>слушатель колбеков тестов для конфигурации</p>
</dd>
<dt class="hdlist1">Selenoid</dt>
<dd>
<p>провайдер веб драйвера для параллельного запуска тестов, содержит внутренний слушатель для allure</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_base_parents">base.parents</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">TestSuite</dt>
<dd>
<p>абстрактный класс для тестовых наборов, регистрирует слушатели</p>
</dd>
<dt class="hdlist1">RestAssuredTest</dt>
<dd>
<p>абстрактный класс для тест кейсов и подшагов, которые работают с rest api</p>
</dd>
</dl>
</div>
</div>
<div class="sect3">
<h4 id="_base_parents_restassuredtest">base.parents.RestAssuredTest</h4>
<div class="dlist">
<dl>
<dt class="hdlist1">initAuth()</dt>
<dd>
<p>инициализация данных для  аутентификации</p>
</dd>
<dt class="hdlist1">httpGet(service, baseuri) : Response</dt>
<dd>
<p>отправка GET запроса</p>
</dd>
<dt class="hdlist1">httpPost(service, json) : Response</dt>
<dd>
<p>отправка POST запроса</p>
</dd>
</dl>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_локаторы">Локаторы</h3>
<div class="paragraph">
<p>Какие виды локаторов бывают:</p>
</div>
<div class="sect3">
<h4 id="_id">ID</h4>
<div class="ulist">
<ul>
<li>
<p>id=&lt;element_id&gt; - соответствует элементу, у которого атрибут id равен значению element_id. Например, у нас есть элемент, который в HTML записывается так:
&lt;input type=text id='some_input_id' name='some_input_name' value='' /&gt; В этом случае локатор будет иметь вид: id=some_input_id.
Также следует отметить, что данный вид локаторов является одним из самых быстрых в нахождении и одним из самых уникальных. Это связано с тем, что в DOM-структуре ссылки на элементы, у которых задан ID, хранятся в отдельной таблице и через JScript (собственно именно через него осуществляется доступ к элементам на конечном уровне) обращение к элементам по ID идет достаточно короткой инструкцией, наподобие some_input_id.
name=&lt;element_name&gt; - соответствует элементу, у которого атрибут name равен значению element_name. Эффективно применяется при работе с полями ввода формы (кнопки, текстовые поля, выпадающие списки). Как правило, значения элементов формы используются в запросах, которые идут на сервер и как раз атрибут name в этих запросах ставит в соответствие поле и его значение. Если брать предыдущий пример:
&lt;input type=text id='some_input_id' name='some_input_name' value='' /&gt; то данный элемент может быть также идентифицирован локатором вида name=some_input_name.
Данный тип локаторов тоже является достаточно быстрым в нахождении, но менее уникальным, так как на странице может быть несколько форм, у которых могут быть элементы с одинаковым именем.</p>
</li>
</ul>
</div>
</div>
<div class="sect3">
<h4 id="_dom">DOM</h4>
<div class="ulist">
<ul>
<li>
<p>dom=&lt;dom_object&gt; - данный тип локатора позволяет обращаться к элементу так же, как и в DHTML используя DOM-структуру. Данный тип локатора используется нечасто, так как обычно находятся более удобные аналоги, но тем не менее данная возможность есть.</p>
</li>
</ul>
</div>
</div>
<div class="sect3">
<h4 id="_link">Link</h4>
<div class="ulist">
<ul>
<li>
<p>link=&lt;link_text&gt; - специально для ссылок используется отдельно зарезервированный тип локаторов, который находит нужную ссылку по ее тексту. Это сделано отчасти потому, что ссылки как правило не имеют таких атрибутов как ID или name. Соответственно, ссылка, которая в HTML записывается так:
&lt;a href='http://some_url'&gt;Link Text 2345&lt;/a&gt;
в Селениуме идентифицируется локатором link=Link Text 2345.
И небольшой частный случай: у ссылки есть фиксированная часть и есть часть, которая может варьироваться. Допустим, в предыдущем примере у нас число может варьироваться. В этом случае мы можем использовать wildcards, в частности '<strong>'. В этом случае, мы можем идентифицировать ссылку локатором вида: link=Link Text</strong> и данный локатор будет соответствовать первой ссылке, текст которой будет начинаться с 'Link Text'.</p>
</li>
</ul>
</div>
</div>
<div class="sect3">
<h4 id="_xpath">XPath</h4>
<div class="ulist">
<ul>
<li>
<p>xpath=&lt;xpath_locator&gt; - наиболее универсальный тип локаторов. Как XPath формируется. HTML, как и его более обобщенная форма - XML, представляет собой различное сочетание тегов, которые могут содержать вложенные теги, а те в свою очередь тоже могут содержать теги и т.д. То есть ,выстраивается определенная иерархия, наподобие структуры каталогов в файловой системе. И задача XPath - отразить подобный путь к нужному элементу, с учетом иерархии. Например, XPath вида:
A/B/C/D указывает на некоторый элемент с тегом D, который находится внутри тега C, а тот в свою очередь - внутри тега B, который находится внутри тега A, который находится на самом верхнем уровне иерархии.
Если брать использование XPath в Селениуме, то там зачастую полный путь указывать не нужно, более того, вредно, особенно, если вложенность тега нужного елемента достаточно высока. Как правило, удобно указывать путь, начиная с некоторого промежуточного элемента, пропуская теги более высокого порядка. Например, такой XPath: //table/tbody/tr/td/a ссылается на первую ссылку в первой строке тела первой таблицы. Обратите внимание на начало данной записи. Строка '//' означает, что поиск элемента начинается с некоторого произвольного места.
У XPath есть много удобств, но есть и основной недостаток - низкая скорость нахождения объекта. В частности, с подобной проблемой можно столкнуться при работе с IE, так как при работе с XPathпод IE используются JScript-библиотеки, которые не отличаются высокой скоростью выполнения. В таких случаях рекомендуется воспользоваться CSS-локаторами (см. ниже), но в некоторых случаях от XPath уйти не получится.</p>
</li>
</ul>
</div>
</div>
<div class="sect3">
<h4 id="_css">CSS</h4>
<div class="ulist">
<ul>
<li>
<p>css=&lt;css_path&gt; - данный тип локаторов основан на описаниях таблиц стилей (CSS), соответственно и синтаксис такой же. В отличие от локаторов по ID, по имени или по тексту ссылки, данный тип локаторов может учитывать иерархию объектов, а также значения атрибутов, что делает его ближайшим аналогом XPath. А в силу того, что объект находится по данному локатору быстрее, чем XPath, рекомендуется прибегать к помощи CSS вместо XPath.
Это основные типы локаторов. Если этого недостаточно, то можно добавить свою стратегию идетнификации элементов, но это отдельная тема. Единственное, что осталось отметить - это тип локаторов, который определяется по умолчанию. В частности, если мы используем локатор, в котором явно не указан тип локатора (отсутствует префикс id=, name=, link=, xpath=, css= и т.п.), то по умолчанию подбирается локатор по следующим правилам:</p>
<div class="ulist">
<ul>
<li>
<p>Если локатор начинается с '//', то используется XPath.</p>
</li>
<li>
<p>Если нет какого-либо префикса, то элемент ищется по ID</p>
</li>
<li>
<p>Если элемент с заданным ID отсутствует, то элемент ищется по атрибуту name.</p>
</li>
</ul>
</div>
</li>
</ul>
</div>
</div>
</div>
<div class="sect2">
<h3 id="_рекомендации">Рекомендации</h3>
<div class="ulist">
<ul>
<li>
<p>По возможности стараемся разгружать тест-кейс, вынося код в сабстепы.</p>
</li>
<li>
<p>При написание тест-кейсов обращайте внимание на ранее созданные сабстепы. Используйте уже готовые сабстепы, чтобы не возникало повторяющегося кода, если подходящего для ваших целей не нашлось - только тогда создавайте свой.</p>
</li>
<li>
<p>Когда названия переменных с элементами пересекаются с названиями переменных со значениями, то предпочтительнее добавить tagname после названия переменной с элементом</p>
</li>
</ul>
</div>
<div class="paragraph">
<p>Например:</p>
</div>
<div class="listingblock">
<div class="content">
<pre class="highlight"><code class="language-kotlin" data-lang="kotlin">val customerName = "John"
val customerNameP get() = `$`(By.xpath("//p"))
val customerNameInput get() = `$`(By.xpath("//input"))
val customerNameA get() = `$`(By.xpath("//a"))</code></pre>
</div>
</div>
</div>
</div>
</div>
</div>
<div id="footer">
<div id="footer-text">
Last updated 2019-01-22 15:39:56 +0200
</div>
</div>
</body>
</html>